﻿Imports Castle.Windsor.Configuration.Interpreters
Imports IoC.Library.infrastructure.commands
Imports IoC.Library.infrastructure
Imports log4net
Imports log4net.Config
Imports MassTransit.WindsorIntegration

<Assembly: XmlConfigurator (Watch := True)>


Module Program

    Private ReadOnly _logger As ILog = LogManager.GetLogger(GetType(Program))

    Sub Main()
        _logger.Debug("Initializing container with values.")
        'Dim windsorContainer As IWindsorContainer = New WindsorContainer(New XmlInterpreter(New ConfigResource("castle")))
        Dim massTransitContainer As DefaultMassTransitContainer = New DefaultMassTransitContainer(New XmlInterpreter())

        Container.initialize_with(massTransitContainer)

        _logger.Debug("Getting commands to run.")
        Dim commands_to_run As ICommandList = Container.get_an_instance(Of ICommandList)()
        For Each command As ICommand In commands_to_run.Commands
            _logger.InfoFormat("Running {0}.", command.GetType().Name)
            command.Run()
        Next

    End Sub

End Module