using System.Collections.Generic;
using employee.system.infrastructure.logging;

namespace employee.system.infrastructure.commands
{
    public class CommandList : ICommandList
    {
        private readonly IEnumerable<ICommand> commands;

        public CommandList(IEnumerable<ICommand> commands)
        {
            Log.bound_to(this).DebugFormat("Initializing {0}", this.GetType().Name);
            this.commands = commands;
        }

        public IEnumerable<ICommand> Commands
        {
            get { return commands; }
        }
    }
}