using employee.system.infrastructure.logging;
using employee.system.messaging.publishing;
using employee.system.orm.repository;

namespace employee.system.infrastructure.commands.custom
{
    public class MessagePublisherCommand<Record, Message> : ICommand
    {
        private readonly IPublisher<Record, Message> publisher;

        public MessagePublisherCommand(IPublisher<Record, Message> publisher)
        {
            this.publisher = publisher;
        }

        public void run()
        {
            Log.bound_to(this).Debug("Message Publisher is gathering records and publishing messages.");
            publisher.publish_the(Repository.get().a_list_of<Record>());
        }
    }
}