using System.Configuration;

namespace employee.system.infrastructure.configuration.custom
{
    public class AdventureWorksConfiguration : ISystemConfiguration
    {
        public string db_connection_string
        {
            get { return ConfigurationManager.ConnectionStrings["AdventureWorksConnString"].ConnectionString; }
        }

        public string get_command
        {
            get
            {
                return "SELECT " +
                       "HumanResources.Employee.EmployeeID " +
                       ",Person.Contact.FirstName " +
                       ",Person.Contact.LastName " +
                       ",HumanResources.Employee.Title " +
                       ",HumanResources.Employee.HireDate " +
                       "FROM HumanResources.Employee " +
                       "INNER JOIN Person.Contact " +
                       "ON HumanResources.Employee.ContactID = Person.Contact.ContactID";
            }
        }
    }
}