using System;
using employee.system.infrastructure.containers;
using employee.system.infrastructure.logging.custom;
using log4net;

namespace employee.system.infrastructure.logging
{
    public static class Log
    {

        public static ILog bound_to(object object_that_needs_logging)
        {
            ILog logger;
            try
            {
                logger = Container.get_an_instance_of<ILogFactory>().create_logger_bound_to(object_that_needs_logging.GetType());
            }
            catch (Exception)
            {
                //Console.WriteLine("Creating the default logger with log4Net. Please register an ILogFactory in the container if you would like to use something else.")
                logger = new Log4NetLogger(LogManager.GetLogger(object_that_needs_logging.GetType().Name));
            }

            return logger;
        }

    }
}