namespace employee.system.infrastructure.logging.custom
{
    public class Log4NetLogger : ILog
    {
        private readonly log4net.ILog logger;

        public Log4NetLogger(log4net.ILog logger)
        {
            this.logger = logger;
        }

        public void Debug(object message)
        {
            logger.Debug(message);
        }

        public void DebugFormat(string message, params object[] args)
        {
            logger.DebugFormat(message, args);
        }

        public void Info(object message)
        {
            logger.Info(message);
        }

        public void InfoFormat(string message, params object[] args)
        {
            logger.InfoFormat(message, args);
        }

        public void Error(object message)
        {
            logger.Error(message);
        }

        public void ErrorFormat(string message, params object[] args)
        {
            logger.ErrorFormat(message, args);
        }

        public void Fatal(object message)
        {
            logger.Fatal(message);
        }

        public void FatalFormat(string message, params object[] args)
        {
            logger.FatalFormat(message, args);
        }
    }
}