using System.Collections.Generic;
using employee.system.infrastructure.containers;
using employee.system.infrastructure.logging;
using MassTransit.ServiceBus;

namespace employee.system.messaging
{
    public static class ServiceBus
    {
        public static void publish<Message>(IList<Message> messages) where Message : class
        {
            Log.bound_to(typeof(ServiceBus).Name).Debug("Grabbing an instance of the service bus.");
            Log.bound_to(typeof(ServiceBus).Name).InfoFormat("Publishing {0} messages of type {1}.", messages.Count,typeof(Message).Name);

            foreach (Message message in messages)
            {
                Container.get_an_instance_of<IServiceBus>().Publish(message);
            }


        }
    }
}