using employee.system.domain;
using employee.system.infrastructure.logging;
using employee.system.infrastructure.mapping;
using employee.system.messaging.messages;

namespace employee.system.messaging.mapping
{
    public class MapFromEmployeeToEmployeeHRMessage : IMapper<IEmployee, EmployeeHRMessage>
    {
        public EmployeeHRMessage map_from(IEmployee from)
        {
            Log.bound_to(this).Debug("Mapping from IEmployee to EmployeeHRMessage.");

            return new EmployeeHRMessage(
                from.employee_id
                , from.title
                , from.first_name
                , from.last_name
                , from.hire_date
                );
        }
    }
}