using employee.system.domain;
using employee.system.infrastructure.logging;
using employee.system.infrastructure.mapping;
using employee.system.messaging.messages;

namespace employee.system.messaging.mapping
{
    public class MapFromEmployeeToEmployeeMessage : IMapper<IEmployee, EmployeeMessage>
    {
        public EmployeeMessage map_from(IEmployee from)
        {
            Log.bound_to(this).Debug("Mapping from IEmployee to EmployeeMessage.");
            return new EmployeeMessage(
                string.Format("{0} {1}", from.first_name, from.last_name)
                , from.hire_date
                , from.title
                );
        }
    }
}