using System.Collections.Generic;
using employee.system.infrastructure.mapping;

namespace employee.system.messaging.publishing
{
    public class Publisher<Record, Message> : IPublisher<Record, Message> where Message : class
    {

        public void publish_the(IEnumerable<Record> records)
        {
            IList<Message> messages = new List<Message>();

            foreach (Record record in records)
            {
                messages.Add(Map.from(record).to<Message>());
            }

            ServiceBus.publish(messages);
        }
    }
}