using System.Data;
using employee.system.infrastructure.configuration;

namespace employee.system.orm.data
{
    public class DataAccess : IDataAccess
    {
        private readonly IDbConnection connection;
        private readonly ISystemConfiguration config;

        public DataAccess(IDbConnection connection, ISystemConfiguration config)
        {
            this.connection = connection;
            this.config = config;
            this.connection.ConnectionString = config.db_connection_string;
        }

        public DataTable get_data_for<DomainType>()
        {
            var dt = new DataTable();

            using (IDbCommand command = connection.CreateCommand())
            {
                command.CommandType = CommandType.Text;
                command.CommandText = config.get_command;

                connection.Open();

                using (IDataReader reader = command.ExecuteReader())
                {
                    dt.Load(reader);
                }
                connection.Close();
            }
            return dt;
        }
    }
}