using System;
using System.Data;
using employee.system.domain;
using employee.system.infrastructure.logging;
using employee.system.infrastructure.mapping;
using employee.system.orm.data.custom;

namespace employee.system.orm.mapping
{
    public class MapFromDataRowToEmployee : IMapper<DataRow, IEmployee>
    {
        public IEmployee map_from(DataRow from_object)
        {
            Log.bound_to(this).Debug("Mapping from IDataReader to IEmployee.");
            

            return new Employee(
                        from_object[EmployeeRowColumns.employee_id]  != DBNull.Value
                           ? (int)from_object[EmployeeRowColumns.employee_id] 
                           : 0
                        , from_object[EmployeeRowColumns.title] != DBNull.Value
                           ? (string)from_object[EmployeeRowColumns.title]
                           : string.Empty
                       , from_object[EmployeeRowColumns.first_name] != DBNull.Value
                           ? (string)from_object[EmployeeRowColumns.first_name]
                           : string.Empty
                       , from_object[EmployeeRowColumns.last_name] != DBNull.Value
                           ? (string)from_object[EmployeeRowColumns.last_name]
                           : string.Empty
                       , from_object[EmployeeRowColumns.hire_date] != DBNull.Value
                           ? (DateTime)from_object[EmployeeRowColumns.hire_date]
                           : new DateTime(0,0,0)
                    );

        }
         
    }
}