using System.Collections.Generic;
using System.Data;
using employee.system.domain;
using employee.system.infrastructure.mapping;
using employee.system.orm.data;

namespace employee.system.orm.repository.custom
{
    public class EmployeeRepository 
    {
        private readonly IDataAccess data_accessor;
        private readonly IMapper<DataRow, IEmployee> mapper;

        public EmployeeRepository(IDataAccess data_accessor,IMapper<DataRow,IEmployee> mapper)
        {
            this.data_accessor = data_accessor;
            this.mapper = mapper;
        }

        public IEnumerable<IEmployee> get_employees()
        {
            foreach (DataRow row in data_accessor.get_data_for<IEmployee>().Rows)
            {
                yield return mapper.map_from(row);
            }
        }
    }
}