using System.Collections.Generic;
using System.Data;
using employee.system.infrastructure.mapping;
using employee.system.orm.data;

namespace employee.system.orm.repository.custom
{
    public class SimpleRepository : IRepository
    {
        private readonly IDataAccess data_accessor;
        private string app_env = "TEST";

        public SimpleRepository(IDataAccess data_accessor)
        {
            this.data_accessor = data_accessor;
        }

        public IEnumerable<DomainType> a_list_of<DomainType>()
        {
            foreach (DataRow row in data_accessor.get_data_for<DomainType>().Rows)
            {
                yield return Map.from(row).to<DomainType>();
            }
        }

        public string application_environment
        {
            get { return app_env; }
            set { app_env  = value; }
        }
    }
}