using Castle.Core.Resource;
using Castle.Windsor;
using Castle.Windsor.Configuration.Interpreters;
using employee.system.lifestyles;
using log4net;

namespace employee.system.runners
{
	public class LifestylesConsoleRunner : IConsoleRunner
	{
		private static readonly ILog _logger = LogManager.GetLogger(typeof (LifestylesConsoleRunner));

		public void run_the_console()
		{
			IWindsorContainer container = new WindsorContainer(new XmlInterpreter(new ConfigResource("castle")));

			ICountingService speaker_counter = container.Resolve<ICountingService>();

			speaker_counter.add_to_amount(25);
			speaker_counter.add_to_amount(2);


			ICountingService attendee_counter = container.Resolve<ICountingService>();
			attendee_counter.add_to_amount(300);
			attendee_counter.add_to_amount(22);

			_logger.InfoFormat("The speaker count is {0}", speaker_counter.total_amount.ToString());
			_logger.InfoFormat("The attendee count is {0}", attendee_counter.total_amount.ToString());
		}
	}
}