using Castle.Windsor.Configuration.Interpreters;
using employee.system.infrastructure.commands;
using employee.system.infrastructure.containers;
using log4net;
using MassTransit.WindsorIntegration;

namespace employee.system.runners
{
    public class MessagesConsoleRunner : IConsoleRunner
    {
        private static readonly ILog _logger = LogManager.GetLogger(typeof (MessagesConsoleRunner));

        public void run_the_console()
        {
            _logger.Debug("Initializing container with values.");
            DefaultMassTransitContainer massTransitContainer = new DefaultMassTransitContainer(new XmlInterpreter());
            
            Container.initialize_with(massTransitContainer);

            _logger.Debug("Getting commands to run.");
            ICommandList commands_to_run = Container.get_an_instance_of<ICommandList>();

            foreach (ICommand command in commands_to_run.Commands)
            {
                command.run();
            }

        }
    }
}