Namespace BeerExample

    Public Class Budweiser
        Implements IBeer

        Private _remainingOunces As Integer
        Private _ounces As Integer

        Public Sub New(ByVal ounces As Integer)
            _ounces = ounces
        End Sub

        Public Function Drink(ByVal ounces As Integer) As Boolean Implements IBeer.Drink
            If (IsEmpty) Then
                RaiseEvent YoureOutOfBeerEvent("Hey! You need a new beer!!")
                Return False
            End If
            If (_remainingOunces < ounces) Then
                ounces = _remainingOunces
            End If
            _remainingOunces -= ounces

            Return True
        End Function

        Public ReadOnly Property IsEmpty() As Boolean Implements IBeer.IsEmpty
            Get
                If (_remainingOunces = 0) Then
                    Return True
                End If

                Return False
            End Get
        End Property

        Public ReadOnly Property Ounces() As Integer Implements IBeer.Ounces
            Get
                Return _ounces
            End Get
        End Property

        Public Event YoureOutOfBeerEvent(ByVal message As String) Implements IBeer.YoureOutOfBeerEvent

    End Class

End Namespace