Imports Castle.Windsor.Configuration.Interpreters
Imports log4net
Imports Castle.Windsor
Imports Castle.Core.Resource

Namespace LifeStyles

    Public Class LifestylesProgram

        Private Shared ReadOnly _logger As ILog = LogManager.GetLogger(GetType(LifestylesProgram))

        Public Sub Run()
            Dim container As IWindsorContainer = New WindsorContainer(New XmlInterpreter(New ConfigResource("castle")))

            Dim speakerCount As ICountingService = container.Resolve(Of ICountingService)()

            speakerCount.AddAmount(25)
            speakerCount.AddAmount(2)

            Dim attendeeCount As ICountingService = container.Resolve(Of ICountingService)()
            attendeeCount.AddAmount(300)
            attendeeCount.AddAmount(22)

            _logger.InfoFormat("The speaker count is {0}", speakerCount.TotalCount.ToString())
            _logger.InfoFormat("The attendee count is {0}", attendeeCount.TotalCount.ToString())
        End Sub

    End Class

End Namespace