Imports IoC.Library.infrastructure.messages
Imports IoC.Library
Imports IoC.Library.infrastructure.publishing
Imports IoC.Library.infrastructure.logging

Namespace infrastructure.commands.custom

    Public Class EmployeePublisherCommand
        Implements ICommand

        Private _publisher As IPublisher(Of IEmployee, EmployeeMessage)
        Private _employeeRepository As EmployeeInformationRepository

        Public Sub New(ByVal publisher As IPublisher(Of IEmployee, EmployeeMessage), ByVal employeeRepository As EmployeeInformationRepository)
            Log.bound_to(Me).DebugFormat("Initializing {0}.", Me.GetType.Name)
            _publisher = publisher
            _employeeRepository = employeeRepository
        End Sub

        Public Sub Run() Implements ICommand.Run
            Log.bound_to(Me).Debug("Employee Publisher is gathering records and publishing messages.")
            _publisher.Publish(_employeeRepository.GetEmployees())
        End Sub

    End Class

End Namespace