Imports IoC.Library.infrastructure.publishing
Imports IoC.Library.infrastructure.repository
Imports IoC.Library.infrastructure.logging

Namespace infrastructure.commands.custom

    Public Class MessagePublisherCommand(Of Record, Message)
        Implements ICommand

        Private _publisher As IPublisher(Of Record, Message)
        Private _repository As IRepository

        Public Sub New(ByVal publisher As IPublisher(Of Record, Message), ByVal repository As IRepository)
            _publisher = publisher
            _repository = repository
        End Sub

        Public Sub Run() Implements ICommand.Run
            Log.bound_to(Me).Debug("Message Publisher is gathering records and publishing messages.")
            _publisher.Publish(_repository.GetList(Of Record))
        End Sub

    End Class

End Namespace