Imports System
Imports IoC.Library.infrastructure.logging.custom
Imports log4net

Namespace infrastructure.logging

    Public Class Log

        Public Shared Function bound_to(ByVal object_that_needs_logging As Object) As ILog
            Dim logger As ILog
            Try
                logger = Container.get_an_instance(Of ILogFactory)().create_logger_bound_to(object_that_needs_logging.GetType())
            Catch ex As Exception
                'Console.WriteLine("Creating the default logger with log4Net. Please register an ILogFactory in the container if you would like to use something else.")
                logger = New Log4NetLogger(LogManager.GetLogger(object_that_needs_logging.GetType().Name))
            End Try

            Return logger
        End Function

    End Class

End Namespace