Imports System.Data
Imports IoC.Library.infrastructure.logging

Namespace infrastructure.mapping.custom

    Public Class MapFromDataReaderToEmployee
        Implements IMapper(Of IDataReader, IEmployee)

        Public Function MapFrom(ByVal item As IDataReader) As IEmployee Implements IMapper(Of IDataReader, IEmployee).MapFrom
            Log.bound_to(Me).Debug("Mapping from IDataReader to IEmployee.")
            Return RehydrateEmployee(item)
        End Function

        Private Function RehydrateEmployee(ByVal dr As IDataReader) As IEmployee
            Return New Employee(CInt(SafeReader(dr.Item("EmployeeID"))), CStr(SafeReader(dr.Item("Title"))), CStr(SafeReader(dr.Item("FirstName"))), CStr(SafeReader(dr.Item("LastName"))), CDate(SafeReader(dr.Item("HireDate"))))
        End Function

        Private Function SafeReader(ByVal dataItem As Object) As Object
            Try
                If (Microsoft.VisualBasic.IsDBNull(dataItem)) Then
                    Return Nothing
                End If
            Catch
                Return Nothing
            End Try

            Return dataItem
        End Function

    End Class

End Namespace