﻿Imports IoC.Library
Imports IoC.Library.infrastructure.mapping
Imports MbUnit.Framework
Imports IoC.Library.DataUtility
Imports IoC.Library.Config
Imports System.Data
Imports Rhino.Mocks


<TestFixture()> _
Public Class As_a_DataAccess

    Private _mocks As MockRepository
    Private _dbConnection As IDbConnection
    Private _config As IConfig
    Private _da As IDataAccess
    Private _mapper As IMapper(Of IDataReader, IEmployee)

    <SetUp()> _
    Public Sub I_want_to()
        _mocks = New MockRepository
        _dbConnection = _mocks.DynamicMock(Of IDbConnection)()
        _config = _mocks.CreateMock(Of IConfig)()
        _mapper = _mocks.CreateMock(Of IMapper(Of IDataReader, IEmployee))()
    End Sub

    <Test()> _
       Public Sub Initialize_properly()
        _da = New DataAccess(_dbConnection, _config, _mapper)
        Assert.IsNotNull(_da)
    End Sub

    <Test()> _
    Public Sub Get_a_list_of_Employees_MOCK()
        Dim cmd As IDbCommand = _mocks.DynamicMock(Of IDbCommand)()
        Dim dr As IDataReader = _mocks.DynamicMock(Of IDataReader)()

        Using _mocks.Record
            Expect.Call(_dbConnection.CreateCommand).Return(cmd)
            Expect.Call(cmd.ExecuteReader).Return(dr)
            Expect.Call(_config.DBConnString).Return("")
            Expect.Call(_config.GetCommand).Return("")
        End Using

        Using _mocks.Playback
            _da = New DataAccess(_dbConnection, _config, _mapper)
            _da.GetList(Of IEmployee)()
        End Using
    End Sub

End Class