﻿Imports MbUnit.Framework
Imports IoC.Library.DataUtility
Imports IoC.Library.Config
Imports System.Data
Imports Rhino.Mocks


<TestFixture()> _
Public Class DataAccessTest

    Private _mocks As New MockRepository

    <Test()> _
    Public Sub GetEmployeesMOCKTest()
        Dim dbConnection As IDbConnection = _mocks.DynamicMock(Of IDbConnection)()
        Dim config As IConfig = _mocks.CreateMock(Of IConfig)()
        Dim cmd As IDbCommand = _mocks.DynamicMock(Of IDbCommand)()
        Dim dr As IDataReader = _mocks.DynamicMock(Of IDataReader)()

        Using _mocks.Record
            Expect.Call(dbConnection.CreateCommand).Return(cmd)
            Expect.Call(cmd.ExecuteReader).Return(dr)
            Expect.Call(config.DBConnString).Return("")
            Expect.Call(config.GetEmployeesCommand).Return("")
        End Using

        Using _mocks.Playback
            Dim da As New DataAccess(dbConnection, config)
            da.GetEmployees()
        End Using
    End Sub

    <Test()> _
    Public Sub ConstructorTest()
        Dim dbConnection As IDbConnection = _mocks.DynamicMock(Of IDbConnection)()
        Dim config As IConfig = _mocks.CreateMock(Of IConfig)()

        Dim da As New DataAccess(dbConnection, config)

        Assert.IsNotNull(da)
    End Sub

End Class