Imports IoC.Library.Config
Imports IoC.Library.DataUtility
Imports IoC.Library
Imports MbUnit.Framework
Imports System.Data.SqlClient
Imports Castle.Windsor

Namespace Integration

    <TestFixture()> _
    Public Class As_a_DataAccess_module

        Private _container As IWindsorContainer

        <SetUp()> _
        Public Sub I_want_to()
            _container = New WindsorContainer()
            _container.AddComponent("conn", GetType(IDbConnection), GetType(SqlConnection))
            _container.AddComponent("config", GetType(IConfig), GetType(NorthwindConfig))
            _container.AddComponent("dal", GetType(IDataAccess), GetType(DataAccess))
        End Sub

        <Test()> _
        Public Sub Get_a_list_of_employees()
            Dim da As IDataAccess = CType(_container.Resolve(GetType(IDataAccess)), IDataAccess)
            Dim employees As IList(Of IEmployee) = da.GetEmployees()
            _container.Release(da)

            Assert.IsNotNull(employees)
            Assert.IsTrue(employees.Count > 0)
        End Sub

    End Class

End Namespace