Imports IoC.Library.Config
Imports IoC.Library.DataUtility
Imports IoC.Library
Imports MbUnit.Framework
Imports Castle.Windsor
Imports System.Data.SqlClient
Imports Rhino.Mocks

Namespace Integration

    <TestFixture()> _
    Public Class As_an_EmployeeInformation

        Private _container As IWindsorContainer
        Private _mocks As MockRepository

        <SetUp()> _
        Public Sub I_want_to()
            _container = New WindsorContainer
            _mocks = New MockRepository
            _container.AddComponent("conn", GetType(IDbConnection), GetType(SqlConnection))
            _container.AddComponent("config", GetType(IConfig), GetType(NorthwindConfig))
            _container.AddComponent("dal", GetType(IDataAccess), GetType(DataAccess))
            _container.AddComponent("emp-info", GetType(EmployeeInformationRepository))
        End Sub

        <Test()> _
                Public Sub Correctly_new_up_myself()
            Dim dataAccess As IDataAccess = _mocks.DynamicMock(Of IDataAccess)()
            Dim employeeInformation As EmployeeInformationRepository = New EmployeeInformationRepository(dataAccess)

            Assert.IsNotNull(employeeInformation)
        End Sub

        <Test()> _
                Public Sub Look_at_my_environment()
            Dim employeeInformation As EmployeeInformationRepository = CType(_container(GetType(EmployeeInformationRepository)), EmployeeInformationRepository)

            Dim environment As String = "DEV"
            employeeInformation.Environment = environment

            Assert.AreEqual(environment, employeeInformation.Environment)
        End Sub

        <Test()> _
        Public Sub Get_a_list_of_Employees()
            Dim employeeInformation As EmployeeInformationRepository = CType(_container(GetType(EmployeeInformationRepository)), EmployeeInformationRepository)
            Dim employees As List(Of IEmployee) = employeeInformation.GetEmployees()
            _container.Release(employeeInformation)

            'collectionassert.AreEqual(employees,)
            Assert.IsNotNull(employees)
            Assert.IsTrue(employees.Count > 0)
        End Sub

    End Class

End Namespace